Subject: Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

From: "Georgios Z. Papadopoulos" <[email-masked]>
Date: Tue, 17 Jul 2018 19:10:02 +0300

Dear Lijo and co-authors,

I went through the draft, please find my comments below:
— — 

High level comments:
*/ [GP] The draft defines the Deadline Time (DT), but it is not clear to me how the arrival of the datagram within this pre-defined DT period is guaranteed?
Indeed, the draft provides the necessary DT information, however, the only action I could observe is the delay-sensitive datagram to be dropped if the indicated DT is elapsed.

*/ [GP] I noticed that there are two different notations for LBR and 6LBR.
Shouldn’t be always 6LBR (6LBR1 and 6LBR2 when it comes to the use-cases in Section 6), instead of LBR, LBR1, LBR2 or 6LBR?

*/ “D flag (1 bit): The 'D' flag, set by the Sender, indicates the action to be taken when a 6LR detects that the deadline time has elapsed. 
If 'D' bit is 1, then the 6LR MUST drop the packet if the deadline time is elapsed. 
If 'D' bit is 0, then the 6LR MAY ignore the deadline time and forward the packet.”

[GP] It is not clear to me why the datagram should be dropped, if the 6LR detects that the DL has elapsed? 
To reduce the traffic in the network or ?

[GP] Then, the main difference in networks where this DRAFT is not considered, is that the packets are not dropped?
Because otherwise the packets are forwarded (when ‘D’ bit is 0).

Detailed comments:
*/ 5. Deadline-6LoRHE Format
“Deadline-6LoRHE encoding with 'O' flag set to 1 :

      DTL = 001, OTL = 001, TU = '10', EXP = 2, DT = 0x22B, OT = 0x22A”

[GP] What about the ‘D’ here?

*/ 6. Deadline-6LoRHE in Three Network Scenarios

[GP] Any router/device may drop the datagram (if it detects that the indicated time has elapsed), both 6LR (Relay devices) and 6LBR (DODAG Root)?

*/ 6.1. Scenario 1: Endpoints in the same DODAG (N1) in non-storing mode.
“Then 6LR begins hop-by-hop operation to forward the packet towards the 6LBR”

[GP] Then 6LR begins or “Then the 6LRs begin”? (not only one 6LR but each 6LR).
OR it should be written as in Scenario 6.3 : “Subsequently, each 6LR will perform hop-by-hop operation to forward the packet towards the 6LBR.”

*/ 6.2. Scenario 2: Endpoints in Networks with Dissimilar L2 Technologies.
“Subsequently, 6LR will perform hop- by-hop operation to forward the packet towards the 6LBR”

[GP] Subsequently, “EACH” 6LR 
OR it should be written as in Scenario 6.3 : “Subsequently, each 6LR will perform hop-by-hop operation to forward the packet towards the 6LBR.”

*/ 6.3. Scenario 3: Packet transmission across different DODAGs (N1 to N2).
“Once the packet reaches LBR2, it updates the Deadline-6LoRHE by adding the current time of DODAG2.”

[GP] is not clear to me, why “adding”, why not “subtracting”, as you mention in page 10.

[GP] Furthermore, in the example later of 6TiSCH network:
Instead of supposing an example of ASN 20050, would make sense actually to have ASN 20030, based on the topology in Figure 6, that comes with three hops.
Similarly, the rest of the math operations could be more specific, based on the topology in Figure 6.

*/ In Scenario 2:
[GP] (Optionally) DODAG 1 could be indicated/highlighted in the Figure 5 as well, as it is illustrated in Figure 6 of Scenario 3.

— — 
Best regards,
Georgios

____________________________________

Georgios Z. Papadopoulos, Ph.D.
Associate Professor, IMT Atlantique, Rennes

web: 	 www.georgiospapadopoulos.com <http://www.georgiospapadopoulos.com/>
twitter: 	@gzpapadopoulos <https://twitter.com/gzpapadopoulos?ref_src=twsrc%5Etfw&ref_url=http://georgiospapadopoulos.com/>
____________________________________

> On Apr 19, 2018, at 02:59, Gabriel Montenegro <[email-masked]> wrote:
> 
> Hi,
>  
> I just initiated a WG last call on:
>  
>               https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/ <https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/>
>  
> The WG last call will finish on Wednesday, May 2, 2018. 
>  
> Thanks in advance for your comments.
>  
> Gabriel
>  
> _______________________________________________
> 6lo mailing list
> [email-masked] <mailto:[email-masked]>
> https://www.ietf.org/mailman/listinfo/6lo <https://www.ietf.org/mailman/listinfo/6lo>

---

From: "Lijo Thomas" <[email-masked]>
Date: Tue, 24 Jul 2018 12:08:49 +0530

Dear Georgios,
 
Thanks for your valuable suggestions and we really appreciate for taking your valuable time for the review .
 
Please find our comments inline below marked as (*** [LT]) 
 
We will be happy to receive your further inputs !!!

Thanks & Regards,
Lijo Thomas 
 
From: 6lo [mailto:[email-masked]] On Behalf Of Georgios Z. Papadopoulos
Sent: 17 July 2018 21:40
To: [email-masked]
Cc: [email-masked]; [email-masked]; Malati Hegde; Samita Chakrabarti; Gabriel Montenegro; lo; Charlie Perkins; [email-masked]
Subject: Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

 
High level comments:

*** [LT] Yes, the Deadline Time (DT) specifies the maximum allowable delay
before which the packet should be delivered to the destination. The proposed
draft provides a mechanism for transporting the DT information. By incorporating
deadline based scheduling/routing mechanisms within the intermediate nodes
using DT, one could guarantee deterministic behavior in terms of delay.

*** [LT] Agreed, we will update the draft.

 
*** [LT] Yes that was the motivation of having 'D' flag to begin with. We
could save bandwidth, and energy etc., by discarding packets whose deadlines
are crossed when 'D' flag is set to 1.

*** [LT] Yes, moreover in some scenarios where the intention is also to know
the total delay experienced by the packets in a network, this could be obtained
by setting 'D' bit set to 0. In such scenarios, we may want to receive the
packets even though the deadline is crossed.
 
Detailed comments:

 
*** [LT] We will update the example by putting 'D' bit = 1.

 
 
*** [LT] Nice suggestion, will update.

 
*** [LT] Will modify the draft

 
*** [LT] Thanks for pointing it out, we will modify the text it as in page 10.

*** [LT] Great observation, we will update the example !!
 
*/ In Scenario 2:
 
*** [LT] Yes we will edit the Figure 5 to incorporate the DODAG 1
 
— — 
Best regards,
Georgios

 
web:      <http://www.georgiospapadopoulos.com> www.georgiospapadopoulos.com
twitter:             <https://twitter.com/gzpapadopoulos?ref_src=twsrc%5Etfw&ref_url=http://georgiospapadopoulos.com/> @gzpapadopoulos
____________________________________
 
On Apr 19, 2018, at 02:59, Gabriel Montenegro < <mailto:[email-masked]> [email-masked]> wrote:
 
Hi,

               <https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/> https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

 
Gabriel
 
_______________________________________________
6lo mailing list
 <mailto:[email-masked]> [email-masked]
 <https://www.ietf.org/mailman/listinfo/6lo> https://www.ietf.org/mailman/listinfo/6lo

-------------------------------------------------------------------------------------------------------------------------------
[ C-DAC is on Social-Media too. Kindly follow us at:
Facebook: https://www.facebook.com/CDACINDIA & Twitter: @cdacindia ]

This e-mail is for the sole use of the intended recipient(s) and may
contain confidential and privileged information. If you are not the
intended recipient, please contact the sender by reply e-mail and destroy
all copies and the original message. Any unauthorized review, use,
disclosure, dissemination, forwarding, printing or copying of this email
is strictly prohibited and appropriate legal action will be taken.
-------------------------------------------------------------------------------------------------------------------------------

---

From: "Georgios Z. Papadopoulos" <[email-masked]>
Date: Tue, 24 Jul 2018 11:18:57 +0300

Hello Lijo,

Thank you so much for your detailed comments. I appreciate it very much.
I am happy with your response, I just have one last clarification point, see below:

> On Jul 24, 2018, at 09:38, Lijo Thomas <[email-masked]> wrote:
> 
> Dear Georgios,
>  
> Thanks & Regards, <>
> From: <> 6lo [mailto:[email-masked] <mailto:[email-masked]>] On Behalf Of Georgios Z. Papadopoulos
> Sent: 17 July 2018 21:40
> To: [email-masked] <mailto:[email-masked]>
> Cc: [email-masked] <mailto:[email-masked]>; [email-masked] <mailto:[email-masked]>; Malati Hegde; Samita Chakrabarti; Gabriel Montenegro; lo; Charlie Perkins; [email-masked] <mailto:[email-masked]>
> Subject: Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/ <https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/>
>  

[GP] Would you agree that this draft do not guarantees deterministic behavior in terms of delay, but it provides
the information of maximum allowable delay for a packet to be delivered to the destination?

To be more precise, for instance, lets us consider the following multi-hop network A—> B —> C.
According this draft, it will required 2 timeslots (or 20ms) for a packet to be delivered at the DODAG Root C.
However, if there is an external interference from A to B, then A may need to retransmit multiple times
in order the datagram to be received by B. Then there are two options according to the draft:
a) the datagram is dropped, to reduce the traffic, energy consumption.
b) the datagram is delivered even if the deadline time is crossed, i.e., as you said in your e-mail “in some scenarios where the intention is also to know the total delay experienced by the packets in a network”

In both bases, a and b, there is no guarantee that the datagram will be delivered in predefined time, i.e., in deterministic behavior. 

— — 
Thank you so much,
Georgios

---

From: "Lijo Thomas" <[email-masked]>
Date: Tue, 24 Jul 2018 14:34:57 +0530

Dear Georgios,

Thanks for the feedback, responding to your query : 

Deadline Time (DT) by itself does not guarantee deterministic behaviour, but its information enables intermediate nodes to implement delay sensitive scheduling and routing algorithms towards achieving deterministic behaviour.

As a use case application of our draft,  we implemented a basic EDF policy in OpenWSN 6tisch stack. 

Please find the link for our openwsn implementation

https://github.com/openwsn-berkeley/openwsn-fw/tree/develop/openapps/uexpiration

Thanks & Regards,

Lijo Thomas 

Sent: 24 July 2018 13:49
To: Lijo Thomas

Hello Lijo,

 

On Jul 24, 2018, at 09:38, Lijo Thomas <[email-masked] <mailto:[email-masked]> > wrote:

Dear Georgios,

 

Thanks & Regards,

Lijo Thomas 

From: 6lo [ <mailto:[email-masked]> mailto:[email-masked]] On Behalf Of Georgios Z. Papadopoulos
Sent: 17 July 2018 21:40
To:  <mailto:[email-masked]> [email-masked]
Cc:  <mailto:[email-masked]> [email-masked];  <mailto:[email-masked]> [email-masked]; Malati Hegde; Samita Chakrabarti; Gabriel Montenegro; lo; Charlie Perkins;  <mailto:[email-masked]> [email-masked]
Subject: Re: [6lo] working group last call (wg lc) on  <https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/> https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

— — 

High level comments:

 

 

— — 

Thank you so much,

Georgios

web:     www.georgiospapadopoulos.com <http://www.georgiospapadopoulos.com> 
twitter:            @gzpapadopoulos <https://twitter.com/gzpapadopoulos?ref_src=twsrc%5Etfw&ref_url=http://georgiospapadopoulos.com/>

---

From: "Georgios Z. Papadopoulos" <[email-masked]>
Date: Tue, 24 Jul 2018 12:39:52 +0300

Dear Lijo,

Many thanks for the clarification.
I am good now.

Best,
Georgios

> On Jul 24, 2018, at 12:04, Lijo Thomas <[email-masked]> wrote:
> 
> Dear Georgios,
>  
> https://github.com/openwsn-berkeley/openwsn-fw/tree/develop/openapps/uexpiration <https://github.com/openwsn-berkeley/openwsn-fw/tree/develop/openapps/uexpiration>
>  
>  
> Thanks & Regards,
> 
> Lijo Thomas 
> 
>  
>> On Jul 24, 2018, at 09:38, Lijo Thomas <[email-masked] <mailto:[email-masked]>> wrote:
>>  
>> Dear Georgios,
>>  
>> From: 6lo [mailto:[email-masked] <mailto:[email-masked]>] On Behalf Of Georgios Z. Papadopoulos
>> Sent: 17 July 2018 21:40
> Facebook: https://www.facebook.com/CDACINDIA <https://www.facebook.com/CDACINDIA> & Twitter: @cdacindia ] 
>

---

From: [email-masked]
Date: Tue, 31 Jul 2018 22:34:58 +0000

Posting again…

From: Chakrabarti, Samita
Sent: Tuesday, July 31, 2018 6:32 PM
To: 'Lijo Thomas' <[email-masked]>; 'Georgios Z. Papadopoulos' <[email-masked]>
Cc: [email-masked]; [email-masked]; 'Malati Hegde' <[email-masked]>; 'Samita Chakrabarti' <[email-masked]>; 'Gabriel Montenegro' <[email-masked]>; 'lo' <[email-masked]>; 'Charlie Perkins' <[email-masked]>; [email-masked]
Subject: RE: [E] Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

Hi Lijo and co-authors:

Here are some more comments on the 6lo-deadline draft:

1.       The abstract of this document says :
   “The deadline time enables forwarding and scheduling decisions for time critical
   IoT M2M applications that need deterministic delay guarantees over
   constrained networks and operate within time-synchronized networks.”

However, the document body seems to indicate that the solution works for 6tisch networks.
Could this document clarify  where this scenario be applicable?  Only 6tisch or any other Low-power networks with multiple hops?
6loRH is a requirement here – so please clarify a typical deployment network where this solution will work [ for example, a Low power network running RPL with 6loRH support on 6lo nodes that create the mesh networks.]

2.       Section 3 – Drop this section and refer to RFC8138 section 4.1

3.       Always provide Normative reference to 6rLoRHE as 6LoRHE[RFC8138] when you refer to it

4.       Section 4 : the calculation is not clear to me as to how it relates the new network clock difference (delta) and the delay in the previous network ( at the entry point of the new network). Please draw a time line diagram and explain  each point what this value is for and how the delay experienced is calculated.  If your reference time for first network is T1, and the second network clock is T1+d  and the dealy in T1 is D1, then at T1+D1 time, when the packet enters the 2nd network, it will read T1+D1+d1 as the 2nd network entry time or origination time in 2nd network. Second network may add some delay in processing the packet. So, I am not clear what is the purpose of this section. Please clarify.

5.       Section 6.2 refers to ietf-ippm-ioam-data – does it have dependency on this draft? What if the border router does not support the ippm draft?  Not sure if I understand the assumption that “It encodes the deadline time (and, if available, the origination time) into the In-band OAM header extension and passes the datagram to the IPv6 layer for further routing…”   Please clarify or drop this scenario.

6.       Section 6.3 again refers to ietf-roll-useofrplinfo draft – is this a dependency?  Can you show a simple scenario where there is no dependency on active draft on another WG?

Thanks,
-Samita

From: 6lo [mailto:[email-masked]] On Behalf Of Lijo Thomas
Sent: Tuesday, July 24, 2018 5:05 AM
To: 'Georgios Z. Papadopoulos' <[email-masked]<mailto:[email-masked]>>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; 'Malati Hegde' <[email-masked]<mailto:[email-masked]>>; 'Samita Chakrabarti' <[email-masked]<mailto:[email-masked]>>; 'Gabriel Montenegro' <[email-masked]<mailto:[email-masked]>>; 'lo' <[email-masked]<mailto:[email-masked]>>; 'Charlie Perkins' <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Subject: [E] Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/

Dear Georgios,

https://github.com/openwsn-berkeley/openwsn-fw/tree/develop/openapps/uexpiration<https://urldefense.proofpoint.com/v2/url?u=https-3A__github.com_openwsn-2Dberkeley_openwsn-2Dfw_tree_develop_openapps_uexpiration&d=DwMFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=nQLGDo_AziW1rJsCvm6vG_oKYbP2VwaFiQPYA9NnaR4&e=>

Thanks & Regards,
Lijo Thomas

From: 6lo [mailto:[email-masked]] On Behalf Of Georgios Z. Papadopoulos
Sent: 24 July 2018 13:49
To: Lijo Thomas
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Malati Hegde; Samita Chakrabarti; Gabriel Montenegro; lo; Charlie Perkins; [email-masked]<mailto:[email-masked]>
Subject: Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/<https://urldefense.proofpoint.com/v2/url?u=https-3A__datatracker.ietf.org_doc_draft-2Dietf-2D6lo-2Ddeadline-2Dtime_&d=DwQFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=5HI37bAJ2WXeO55wDC3VhtutrxRLoXJ_sn64hp3EF3M&e=>

Hello Lijo,

On Jul 24, 2018, at 09:38, Lijo Thomas <[email-masked]<mailto:[email-masked]>> wrote:

Dear Georgios,

Thanks & Regards,
Lijo Thomas

From: 6lo [mailto:[email-masked]] On Behalf Of Georgios Z. Papadopoulos
Sent: 17 July 2018 21:40
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; Malati Hegde; Samita Chakrabarti; Gabriel Montenegro; lo; Charlie Perkins; [email-masked]<mailto:[email-masked]>
Subject: Re: [6lo] working group last call (wg lc) on https://datatracker.ietf.org/doc/draft-ietf-6lo-deadline-time/<https://urldefense.proofpoint.com/v2/url?u=https-3A__datatracker.ietf.org_doc_draft-2Dietf-2D6lo-2Ddeadline-2Dtime_&d=DwMFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=5HI37bAJ2WXeO55wDC3VhtutrxRLoXJ_sn64hp3EF3M&e=>

High level comments:

— —
Thank you so much,
Georgios

web:     www.georgiospapadopoulos.com<https://urldefense.proofpoint.com/v2/url?u=http-3A__www.georgiospapadopoulos.com&d=DwMFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=_1Xvis_IS2XJLj901j7We2qqeGomCqtC6KCdIizcBsQ&e=>
twitter:            @gzpapadopoulos<https://urldefense.proofpoint.com/v2/url?u=https-3A__twitter.com_gzpapadopoulos-3Fref-5Fsrc-3Dtwsrc-255Etfw-26ref-5Furl-3Dhttp-3A__georgiospapadopoulos.com_&d=DwMFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=jpu1BQDn6eUhHwMQ_kX4LwHwL_qtu9wlDc-YwyqE6Ig&e=>
____________________________________

-------------------------------------------------------------------------------------------------------------------------------
[ C-DAC is on Social-Media too. Kindly follow us at:
Facebook: https://www.facebook.com/CDACINDIA<https://urldefense.proofpoint.com/v2/url?u=https-3A__www.facebook.com_CDACINDIA&d=DwQFaQ&c=udBTRvFvXC5Dhqg7UHpJlPps3mZ3LRxpb6__0PomBTQ&r=pWMzx7FsqijEJPyfMBfn-HJss-wVVTf0K5y-cxCTXL8&m=7e5GkJIcbIxuUVNca7qMqtU6Wk2lwaz89_SQAfJoyPY&s=qAVDzBnrxBMh4W5vZkkX3lGHT3D8czZnJSW7Z5t93R4&e=> & Twitter: @cdacindia ]